summaryrefslogtreecommitdiff
path: root/tests/tail-2
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2009-12-29 13:47:10 +0100
committerJim Meyering <meyering@redhat.com>2009-12-29 17:01:54 +0100
commitfd93fc3ef4947f4712a4bda08b6e11c0d6cdf48a (patch)
treecab13ae371308442910b3556732ccdb3e299b852 /tests/tail-2
parentbd26efaaa3e251c4a1bed308ec5ee500ecfd7d25 (diff)
downloadcoreutils-fd93fc3ef4947f4712a4bda08b6e11c0d6cdf48a.tar.xz
tail: add another test to exercise abort-inducing flaw in tail -F
* tests/tail-2/inotify-hash-abuse2: New test, based on a reproducer by Rob Wortman. * tests/Makefile.am (TESTS): Add it.
Diffstat (limited to 'tests/tail-2')
-rwxr-xr-xtests/tail-2/inotify-hash-abuse250
1 files changed, 50 insertions, 0 deletions
diff --git a/tests/tail-2/inotify-hash-abuse2 b/tests/tail-2/inotify-hash-abuse2
new file mode 100755
index 000000000..2f59eb4d5
--- /dev/null
+++ b/tests/tail-2/inotify-hash-abuse2
@@ -0,0 +1,50 @@
+#!/bin/sh
+# Exercise an abort-inducing flaw in inotify-enabled tail -F.
+# Like inotify-hash-abuse, but without a hard-coded "9".
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+touch f || framework_failure
+
+debug='---disable-inotify -s .001'
+debug=
+timeout 10 tail $debug -F f & pid=$!
+
+for i in $(seq 200); do
+ kill -0 $pid || break;
+ mv f g
+ touch f
+done
+
+# Fixed tail will not have aborted. Kill it.
+kill -HUP $pid
+
+wait $pid
+st=$?
+
+case $st in
+ 129) ;;
+ *) echo tail died via unexpected signal: $st; fail=1;;
+esac
+
+Exit $fail